package com.kxs.stat.api.amqp.rabbit;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.kxs.common.mq.enums.MQSendTypeEnum;
import com.kxs.common.mq.model.AbstractMQ;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.springframework.amqp.core.Message;
import org.springframework.amqp.core.MessageBuilder;
import org.springframework.amqp.core.MessageDeliveryMode;
import org.springframework.amqp.core.MessageProperties;

import java.math.BigDecimal;
import java.util.UUID;

/**
 * mq 订单普通队列 配置
 *
 * @author 没秃顶的码农
 * @date 2024-04-25
 */
@Data
@EqualsAndHashCode(callSuper = true)
@NoArgsConstructor
@AllArgsConstructor
public class RabbitLkbTradeQueueMQ extends AbstractMQ {


    /**
     * 订单交易队列
     */
    public static final String QUEUE_NAME = "QUEUE_LKB_TRADE_DIVISION";

    /**
     * 死队列名称
     */
    public static final String DEAD_QUEUE_NAME = null;

    /**
     * 内置msg 消息体定义
     **/
    private MsgEntity msgEntity;

    /**
     *  定义Msg消息载体
     **/
    @Data
    public static class MsgEntity {

        /**
         * 订单状态（0待支付，1已支付）
         */
        private String  status;
        /**
         * 订单创建时间
         */
        private String createDate;
        /**
         * 支付时间
         */
        private String payDate;
        /**
         * 好哒订单号
         */
        private String hdOrderNo;
        /**
         * 支付宝微信平台交易号
         */
        private String tradeNo;
        /**
         * 码牌SN
         */
        private String snNo;
        /**
         * 支付金额
         */
        private BigDecimal payMoney;
        /**
         * 支付方式（1支付宝，2微信）
         */
        private String payMode;
        /**
         * 订单号
         */
        private String orderNo;
        /**
         * 商户Id
         */
        private String merchantId;
        /**
         * 活动标识（1活动，0非活动）
         */
        private String isAct;
        /**
         * 用户ID
         */
        private Integer userId;
        /**
         * 激活时间
         */
        private Integer  brandId;


    }

    @Override
    public String getQueueName() {

        return QUEUE_NAME;
    }

    @Override
    public String getDeadQueueName() {

        return DEAD_QUEUE_NAME;
    }

    @Override
    public MQSendTypeEnum getMqType() {

        return MQSendTypeEnum.QUEUE;
    }

    @Override
    public Message toMessage() {
        String message = JSONObject.toJSONString(msgEntity);
        // 构建消息体
        return MessageBuilder.withBody(message.getBytes())
                .setContentType(MessageProperties.CONTENT_TYPE_TEXT_PLAIN)
                .setDeliveryMode(MessageDeliveryMode.PERSISTENT)
                .setMessageId(UUID.randomUUID().toString())
                .build();
    }

    /**
     * 构造发送消息
     */
    public static RabbitLkbTradeQueueMQ build(MsgEntity message){

        return new RabbitLkbTradeQueueMQ(message);
    }

    /**
     * 解析MQ消息， 一般用于接收MQ消息时
     */
    public static MsgEntity parse(String msg){
        return JSON.parseObject(msg, MsgEntity.class);
    }

}
